/*
 * 
 * Steath Scanning Taktik
 * by aempirei
 * uses FIN tekneek therefore is not 100% accurate
 * and it only scans a pre-determined list of port numbers
 * as defined in int pslist[20]
 */

#include "mns.h"

void init_tcpip(int *, int *);
void sendtcp(int, hdrinfo *, u_short, short);
short gettcp(int, hdrinfo *, struct tcphdr *);

void main(int argc, char *argv[]) {
   int i, j;
   SAin src, dst;
   int sd_send, sd_recv;
   hdrinfo spoof;
   struct tcphdr itcp;
   int pslist[20] = { 7, 15, 19, 13, 21, 23, 25, 37, 53, 79,
	             80, 88,110,111,113,137,139,143,513,520 };
   int pschkd[20];
   long timeout;
   
   for(i = 0; i < 20; pschkd[i] = i++);
      
   srand(time(NULL));
   
   init_tcpip(&sd_send, &sd_recv);
   
#define usage(a) {printf("usage: %s <source> <destination>\n", (a)); exit(0);}
   
   if(argc < 3) usage(argv[0]);
   
   bzero(&src, sizeof(SAin));
   bzero(&dst, sizeof(SAin));
   
   if(!ipv4_rslvhost(argv[1], &src)) usage(argv[0]);
   if(!ipv4_rslvhost(argv[2], &dst)) usage(argv[0]);
   
   printf("source: %s\n", inet_ntoa(src.sin_addr));
   printf("  dest: %s\n\n", inet_ntoa(dst.sin_addr));
   
   spoof.sport = (rand() % 10000) + 5000;

#define sendtcppacket(a)\
   {spoof.seq = rand();\
   sendtcp(sd_send, &spoof, (a), 1);}
   
   spoof.ack = 0;
   spoof.from = src;   
   spoof.dest = dst;

   for(i = 0; i < 20; i++) {
      spoof.dport = pslist[i];

      sendtcppacket(FIN);
      usleep(5);
      
      if(gettcp(sd_recv, &spoof, &itcp))
	for(j = 0; j < 20; j++)
	  if(pslist[j] == ntohs(itcp.th_sport)) {
	     pschkd[j] = 0;
	     j = 20;
	  }
   }
   
   timeout = time(NULL) + 2;

   while (timeout > time(NULL)) {
      if (gettcp (sd_recv, &spoof, &itcp))
	for(j = 0; j < 20; j++)
	   if(pslist[j] == ntohs(itcp.th_sport)) {
	      pschkd[j] = 0;
	      j = 20;
	   }
   }
   
   printf("%s: ", argv[2]);
   for(i = 0; i < 20; i++)
      if(pschkd[i]) printf(" %i", pslist[i]);
   
   putchar('\n');
}

/* Sends a TCP packet */
void sendtcp(int sd_send, hdrinfo *spoof, u_short flags, short rep) {
   struct tcphdr tcp;
   struct ip ip;
   static char pkt[8192];
   int i;

/*-- IP HDR --*/
   ip.ip_hl = 5;
   ip.ip_v = 4;
   ip.ip_tos = 0;
   ip.ip_len = htons (40);
   ip.ip_id = htons (spoof->sport);
   ip.ip_off = 0;
   ip.ip_ttl = 255;
   ip.ip_p = IPPROTO_TCP;
   ip.ip_src = spoof->from.sin_addr;
   ip.ip_dst = spoof->dest.sin_addr;
#ifdef HAVE_STRUCT_IP_CSUM
#define ip_sum ip_csum
#endif
   ip.ip_sum = 0;
   ip.ip_sum = in_cksum((u_short *)&ip, sizeof(ip));

   /*-- TCP HDR --*/
   tcp.th_sport = htons (spoof->sport);
   tcp.th_dport = htons (spoof->dport);
   tcp.th_seq = htonl (spoof->seq);
   tcp.th_ack = 0;
#ifdef X2_OFF
   tcp.th_x2_off = 0x50;
#else
   tcp.th_x2 = 0;
   tcp.th_off = 5;
#endif /* X2_OFF */
   tcp.th_flags = flags;
   tcp.th_win = htons (0x1234);
   tcp.th_urp = 0;
   tcp.th_sum = 0;

/*-- TCP Checksum --*/
#ifdef SOLARIS_CKSUM_BUG
   tcp.th_sum = sizeof(struct tcphdr);
#else 
   tcp.th_sum = tcp_cksum((char *)&tcp,
		          sizeof (struct tcphdr),
			  spoof->from.sin_addr,
			  spoof->dest.sin_addr);
#endif /* SOLARIS_CKSUM_BUG */

   memcpy(pkt, (char *)&ip, sizeof(ip));
   memcpy(pkt + sizeof(ip), (void *)&tcp, sizeof(tcp));

   for (i = 0; i < rep; i++)
   if (sendto(sd_send, (void *)pkt, sizeof(ip) + sizeof(tcp), 0, (SA *)&spoof->dest, sizeof(spoof->dest)) < 0)
      perror ("sending message");

}

/* Get's a TCP packet */
#define MAXSIZE	65535

short gettcp(int sd_recv, hdrinfo *spoof, struct tcphdr *dtcp) {
   char packet[MAXSIZE];
#define ippak ((struct ip *)packet)
#define tcppak ((struct tcphdr *)&packet[20])
   
   if (read(sd_recv, packet, MAXSIZE) < 0)
     return 0;
       
   /* Check to see if it's a TCP/IP packet from the proper host */
   if (spoof->dest.sin_addr.s_addr != ippak->ip_src.s_addr)
     return 0;

   memcpy(dtcp, tcppak, sizeof(struct tcphdr));
   return 1;
}

void init_tcpip(int *sd_send, int *sd_recv) {
   int on = 1;
   int rsflags;
  
  /*-- SEND RAW socket --*/
   if((*sd_send = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0) {
      perror ("opening raw send socket");
      exit (EXIT_FAILURE);
   }
   if(setsockopt(*sd_send, IPPROTO_IP, IP_HDRINCL, &on, sizeof(int)) < 0) {
      perror ("setting option IP_HDRINCL");
      exit (EXIT_FAILURE);
    }

   /*-- READ RAW socket --*/
   if((*sd_recv = socket(AF_INET, SOCK_RAW, IPPROTO_TCP)) < 0) {
      perror ("opening raw read socket");
      exit (EXIT_FAILURE);
   }
   if((rsflags = fcntl(*sd_recv, F_GETFL)) == -1) {
      perror ("fcntl(sd_recv,F_GETFL)");
      exit (EXIT_FAILURE);
   }
   if (fcntl(*sd_recv, F_SETFL, rsflags | O_NONBLOCK) == -1) {
      perror ("fcntl(sd_recv,F_SETFL)");
      exit (EXIT_FAILURE);
   }
}

